<script setup lang="tsx">
import { ContentWrap } from '@/components/ContentWrap'
import { Search } from '@/components/Search'
import { Dialog } from '@/components/Dialog'
import { useI18n } from '@/hooks/web/useI18n'
import { ElButton, ElLink, ElPopconfirm, ElMessage } from 'element-plus'
import { Table } from '@/components/Table'
import { saveTableApi, delTableListApi, getTableTempConfigListApi } from '@/api/table'
import { useTable } from '@/hooks/web/useTable'
import { TableData } from '@/api/table/types'
import { ref, unref, reactive } from 'vue'
import Write from './components/Write.vue'
import Detail from './components/Detail.vue'
import { CrudSchema, useCrudSchemas } from '@/hooks/web/useCrudSchemas'

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getTableTempConfigListApi({
      pageNum: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.data.list,
      total: res.data.total
    }
  },
  fetchDelApi: async () => {
    const res = await delTableListApi(unref(ids))
    return !!res
  }
})
const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const searchParams = ref({})
const setSearchParams = (params: any) => {
  searchParams.value = params
  getList()
}

const { t } = useI18n()

const crudSchemas = reactive<CrudSchema[]>([
  {
    field: 'selection',
    search: {
      hidden: true
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    },
    table: {
      type: 'selection'
    }
  },
  {
    field: 'index',
    label: t('tableDemo.index'),
    type: 'index',
    search: {
      hidden: true
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'formatName',
    label: '报表类型',
    search: {
      component: 'Select',
      componentProps: {
        options: [
          {
            label: '补录',
            value: 0
          },
          {
            label: '填报',
            value: 1
          }
        ]
      }
    },
    detail: {
      hidden: true
    },
    table: { hidden: true },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    }
  },
  {
    field: 'reportCode',
    label: t('tableDemo.reportcoding'),
    search: {
      hidden: true
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'reportName',
    label: t('tableDemo.name'),
    search: {
      component: 'Input'
    },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'systemCode',
    label: t('tableDemo.owningsystem'),
    search: {
      component: 'Select',
      componentProps: {
        options: [
          {
            label: 'portal',
            value: 0
          },
          {
            label: 'srdb',
            value: 1
          }
        ]
      }
    },
    table: {
      show: false
    },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'createTime',
    label: t('tableDemo.displayTime'),
    search: {
      component: 'DatePicker'
    },
    // form: {
    //   component: 'DatePicker',
    //   componentProps: {
    //     type: 'datetime',
    //     valueFormat: 'YYYY-MM-DD HH:mm:ss'
    //   }
    // }
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'updateTime',
    label: t('tableDemo.updatetime'),
    search: {
      component: 'DatePicker'
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    }
    // form: {
    //   component: 'Select',
    //   componentProps: {
    //     style: {
    //       width: '110%'
    //     },
    //     options: [
    //       {
    //         label: '重要',
    //         value: 3
    //       },
    //       {
    //         label: '良好',
    //         value: 2
    //       },
    //       {
    //         label: '一般',
    //         value: 1
    //       }
    //     ]
    //   }
    // },
    // detail: {
    //   slots: {
    //     default: (data: any) => {
    //       return (
    //         <ElTag
    //           type={
    //             data.importance === 1 ? 'success' : data.importance === 2 ? 'warning' : 'danger'
    //           }
    //         >
    //           {data.importance === 1
    //             ? t('tableDemo.important')
    //             : data.importance === 2
    //             ? t('tableDemo.good')
    //             : t('tableDemo.commonly')}
    //         </ElTag>
    //       )
    //     }
    //   }
    // }
  },
  {
    field: 'formatName',
    label: t('tableDemo.templatename'),
    search: {
      hidden: true
    },
    detail: {
      hidden: true
    },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    }
  },
  {
    field: 'datasetId',
    label: t('tableDemo.datasetcoding'),
    search: {
      hidden: true
    },
    // form: {
    //   component: 'InputNumber',
    //   value: 0
    // }
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    }
  },
  {
    field: 'charSet',
    label: t('tableDemo.characterset'),
    search: {
      hidden: true
    },
    detail: {
      hidden: true
    },
    table: {
      show: false
    },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    }
  },
  {
    field: 'serviceType',
    label: t('tableDemo.servicetype'),
    search: {
      hidden: true
    },
    table: {
      show: false
    },
    form: {
      component: 'Input',
      colProps: {
        span: 24
      }
    },
    detail: {
      hidden: true
    }
  },
  {
    field: 'format',
    label: '报文模版',
    table: {
      hidden: true
    },
    form: {
      hidden: true
    },
    search: {
      hidden: true
    },
    detail: { hidden: false }
  },
  {
    field: 'action',
    width: '160px',
    label: t('tableDemo.action'),
    search: {
      hidden: true
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    },
    table: {
      slots: {
        default: (data: any) => {
          return (
            <>
              <ElLink type="primary" underline={false} onClick={() => action(data.row, 'edit')}>
                {t('exampleDemo.edit')}
              </ElLink>
              <ElLink type="primary" underline={false} onClick={() => action(data.row, 'detail')}>
                {'报文模版'}
              </ElLink>
              <ElPopconfirm
                title={t('common.delTableMsg')}
                width={200}
                v-slots={{
                  reference: () => {
                    return (
                      <>
                        <ElLink type="primary" underline={false}>
                          {t('exampleDemo.del')}
                        </ElLink>
                      </>
                    )
                  }
                }}
                onConfirm={() => delAloneData(data.row)}
              ></ElPopconfirm>
            </>
          )
        }
      }
    }
  }
])

// @ts-ignore
const { allSchemas } = useCrudSchemas(crudSchemas)

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref<TableData | null>(null)
const actionType = ref('')

const AddAction = () => {
  dialogTitle.value = t('exampleDemo.add')
  currentRow.value = null
  dialogVisible.value = true
  actionType.value = ''
}

const delLoading = ref(false)

const delData = async (row: TableData | null) => {
  const elTableExpose = await getElTableExpose()
  ids.value = row ? [row.id] : elTableExpose?.getSelectionRows().map((v: TableData) => v.id) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

const delAloneData = async (row: TableData) => {
  delLoading.value = true
  const res = await delTableListApi([row.id])
    .catch(() => {})
    .finally(() => {
      delLoading.value = false
    })
  delLoading.value = false
  if (res) {
    const { code } = res.data
    if (code === 1) {
      ElMessage.success('操作成功!')
      getList()
    } else {
      ElMessage.error('操作失败!')
    }
  }
}

const action = (row: TableData, type: string) => {
  dialogTitle.value = type === 'edit' ? '编辑' : '报文模版'
  actionType.value = type
  currentRow.value = row
  dialogVisible.value = true
}

const writeRef = ref<ComponentRef<typeof Write>>()

const saveLoading = ref(false)

const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveTableApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}
</script>

<template>
  <ContentWrap>
    <Search :schema="allSchemas.searchSchema" @search="setSearchParams" @reset="setSearchParams" />

    <Table
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      :columns="allSchemas.tableColumns"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total: total
      }"
      @register="tableRegister"
      @refresh="refresh"
      @selection-change="onSelectionChange"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('exampleDemo.add') }}</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delData(null)">
          {{ t('exampleDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write
      v-if="actionType !== 'detail'"
      ref="writeRef"
      :form-schema="allSchemas.formSchema"
      :current-row="currentRow"
    />

    <Detail
      v-if="actionType === 'detail'"
      :detail-schema="allSchemas.detailSchema"
      :current-row="currentRow"
    />

    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('exampleDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>
